<template>
  <v-card style="background-color: transparent !important;" elevation="0">
    <slot name="header">
      <v-card-title class="pb-0">
        <p style="font-size: 14px">Купить</p>
      </v-card-title>
    </slot>
    <v-container fluid>
      <v-row dense>
        <template v-if="offers && offers.length">
          <v-col cols="12" sm="6" md='4' v-for="offer in offers" :key="offer.id">
            <offer-list-item
              v-if="isBuyOffer(offer)"
              :offer="offer"
              @buy="$emit(`buy`, offer)"
            />
            <offer-sell-list-item
              v-else-if="isSellOffer(offer)"
              :offer="offer"
              @sell="$emit(`sell`, offer)"
            />
          </v-col>
        </template>
        <template v-else>
          <slot name="empty"></slot>
        </template>
      </v-row>
    </v-container>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { OfferResponse } from '@/api/ledius-token';
import { Prop } from 'vue-property-decorator';
import OfferListItem from './OfferListItem.vue';
import { OfferTypeEnum } from '@/api/patch/ledius-token.enums';
import OfferSellListItem from '@/components/offers/OfferSellListItem.vue';

@Component({
  components: {
    OfferListItem,
    OfferSellListItem
  }
})
export default class OffersList extends Vue {
  @Prop({
    required: true,
    type: Array
  })
  private readonly offers!: OfferResponse[];

  private isSellOffer = (offer: OfferResponse): boolean =>
    (offer.type as never) === OfferTypeEnum.SELL;

  private isBuyOffer = (offer: OfferResponse): boolean =>
    (offer.type as never) === OfferTypeEnum.BUY;
}
</script>

<style scoped></style>
